<%@ page contentType="text/html; charset=utf-8" %>
<%@ page language="java" %>
<%@ page errorPage="/errorPage.jsp" %>
<% try { // START: DEBUG %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/citation.tld" prefix="citation" %>

<%@ page import="com.sas.apps.citation.controller.action.CitationDialogAction" %>
<%@ page import="com.sas.apps.citation.view.beans.PagePropertyBean" %>
<%@ page import="com.sas.apps.citation.view.tbeans.html.CitationButton" %>
<%@ page import="com.sas.apps.citation.view.util.PageErrorProcessor" %>
<%@ page import="com.sas.apps.citation.view.util.ThemeUtils" %>
<%@ page import="com.sas.apps.citation.view.util.ViewUtils" %>

<html:xhtml />
<script type="text/javascript" src="scripts/citation_groupBreakUtils.js"></script>

<%
    Object rc = request.getAttribute(CitationDialogAction.RESULT_CODE_KEY);
    Object cmdKey = request.getAttribute(CitationDialogAction.DIALOG_CMD_KEY);
    if( CitationDialogAction.RC_SUCCESS.equals(rc)
        && CitationDialogAction.CMD_OK_DIALOG_KEY.equals(cmdKey))
    { 
%>
<script type="text/javascript"> /*<![CDATA[*/
    window.opener.forceReloadCurrentPage();
    window.close();
/*]]>*/ </script>
<%      return; //exit out of service method preventing recreation of form-bean on close
    } 
%>
<jsp:useBean id="builderGroupBreaksDialogForm" class="com.sas.apps.citation.view.beans.reportbuilder.BuilderGroupBreaksDialogFormBean" scope="session" />
<%
int maxByGroups = builderGroupBreaksDialogForm.getMaxByGroupCount();
String singleDataItemMessage = 	ViewUtils.escapeForJavaScript(PagePropertyBean.getMessage(pageContext, "message.groupbreak.dataitem.in.use.fmt.txt"));
String multipleDataItemMessage = ViewUtils.escapeForJavaScript(PagePropertyBean.getMessage(pageContext, "message.groupbreak.dataitems.in.use.fmt.txt"));
%>
<script src="scripts/citation_fontPicker.js" type="text/javascript"></script>
<script type="text/javascript"> /*<![CDATA[*/
    function enableLabelCategories() {
    	<%-- label categories enabled only if there are group breaks --%>
    	var labelValue = findDOM('labelValue');
    	var noGroupBreaks = (findDOM('bygroupLevel1').selectedIndex == 0);
    	labelValue.disabled = noGroupBreaks;
    	findDOM('labelValueLabel').className = (noGroupBreaks) ? "labeldisabled" : "label";
    	findDOM('formatBox').disabled = noGroupBreaks;
    	findDOM('formatBoxTitle').className = (noGroupBreaks) ? "headerDisabled" : "header";
    	showToolbar(noGroupBreaks);
    	var state = (noGroupBreaks) ? setButtonState.DISABLED : setButtonState.ENABLED;
        setButtonState(null, 'dynamicTextTab', state, 'dialogTab', false);
        // if not active, make it only *look* disabled
    	if (findDOM('dynamicTextTab').cwIsActive == false) {
	        setButtonState(null, 'dynamicTextTab', setButtonState.DISABLED, 'dialogTab', true);
    	}
    	if (noGroupBreaks) {
    		findDOM('dtChoicesSelect').options.length = 0;
    	}
    }
    
    function showToolbar(noGroupBreaks) {
    	
        var fgcolorPickerId = "color_Obj";
        var bgcolorPickerId = "backgroundColor_Obj";
        if (noGroupBreaks) {
            eval(fgcolorPickerId).disable();
            eval(bgcolorPickerId).disable();
            eval(groupBreaksFontPicker).setEnabled(false);
            findDOM('byGroupSampleText').style.color = 'gray';
        } else {
            eval(fgcolorPickerId).enable();
            eval(bgcolorPickerId).enable();
            eval(groupBreaksFontPicker).setEnabled(true);
            findDOM('byGroupSampleText').style.color = eval(fgcolorPickerId).getSelectedItem();
        }
    }

    function onSubmit()
    {
    	var listOfLabels = checkInUse(<%=maxByGroups%>, 'bygroupLevel', 'inUseString');
    	if (listOfLabels.length > 0) {
    		var message = "";
    		var labels = "";
    		if (listOfLabels.length > 1) {
	    		message = '<%=multipleDataItemMessage%>';
	    		labels = listOfLabels.join(", ");
    		}
    		else {
	    		message = '<%=singleDataItemMessage%>';
	    		labels = listOfLabels[0];
    		}
   	
    		message = message.replace(/\{0\}/i, labels);
    		if (!confirm(message)) {
    			return;
    		}
    	}
        var choices = findDOM('dtChoicesSelect');
        var measures="";
        for (var i=0; i < choices.options.length; i++)
        {
            measures += choices.options[i].value;
            measures += ';';
        }
        findDOM('hiddenVisibleMeasures').value = measures;
        document.forms['builderGroupBreaksDialogForm'].submit();
    }
    function onLoad()
    {
	    // document.body.onmousedown = onMousedown; // Removed for S0927913 causes older Firefox pull downs to freeze.
        document.body.onkeydown = onKeydown;
    }

    
    // If the mouse is clicked outside of the color picker, close the color picker. Otherwise,
    // process the mouse down event.
    function onMousedown()
    {
		return false;
    }
    
    // If the escape key is pressed and a color picker is visible, hide it. Otherwise, if
    // the return key is pressed and the colorpicker is visible, ignore it. Otherwise, let
    // the default handling occur.
    function onKeydown()
    {
		return true;
    }

/*]]>*/ </script>
<input type="hidden" name="sortString" id="sortString" value="<%=builderGroupBreaksDialogForm.getSortString() %>" />
<input type="hidden" name="inUseString" id="inUseString" value="<%=builderGroupBreaksDialogForm.getInUseString() %>" />

        <%-- general property sheet declaration --%>
    <table id="groupBreakTabBody" summary=""
       style="display:block; border:none; border-collapse:collapse; width:600px; height:420px;" 
       >
    <tr>
        <td class="marginPadding">&nbsp;</td>
        <td colspan="2" style="white-space:nowrap;">
            <span class="header"><bean:message key='groupbreak.general.levels.txt'/></span>
        </td>
        <td class="marginPadding">&nbsp;</td>
    </tr>
    <tr>
        <td class="marginPadding">&nbsp;</td>
        <td colspan="2" style="vertical-align:top;">
            <div class="groupBreakItems">
                <table border="0" cellspacing="0" cellpadding="0" summary="">
                    <tr>
                        <td colspan="5" class="linePadding">&nbsp;</td>
                    </tr>
<%    
    for (int rowNum=1, len=maxByGroups; rowNum<=len; rowNum++)
    {
        String onChange=
            "javascript:enableElement(" + maxByGroups + ", 'bygroupLevel', 'newPageCheckedLabel', 'newPageChecked', 'bygroupSort', 'sortLabel', 'sortString'); enableLabelCategories()";        
        String dropdownHeader = (rowNum == 1) ?
			PagePropertyBean.getMessage(pageContext, "groupbreak.general.breakby.txt") :
			PagePropertyBean.getMessage(pageContext, "groupbreak.general.thenby.txt");
        String selectPropertyName = "bygroupLevel(" + Integer.toString(rowNum-1) + ")";
	    String radioPropertyName = "bygroupSort(" + Integer.toString(rowNum-1) + ")";
        String selectStyleId = "bygroupLevel" + rowNum;
	    String radioStyleId1 = "bygroupSort" + rowNum;
	    String radioStyleId2 = "bygroupSort" + rowNum +"_2";
        String checkboxPropertyName = "newPageChecked(" + Integer.toString(rowNum-1) + ")";
        String checkboxStyleId = "newPageChecked" + rowNum;
        String labelStyleId = "newPageCheckedLabel" + rowNum;
	    String sortLabelStyleId = "sortLabel" + rowNum;
	    String sortLabelStyleId2 = "sortLabel" + rowNum +"_2";
        String onclick = "javascript:checkPreviousBox('newPageChecked'," + rowNum + 
                ");uncheckNextBox('newPageChecked'," + rowNum + "," + len + ");";

%>
            <tr>
                <td class="dialogSpacer">&nbsp;</td>
                <td class="header"><%= dropdownHeader %></td>
                <td class="dialogSpacer">&nbsp;</td>
<%
	if (rowNum == 1)
	{
%>
	  	<td style="white-space:nowrap;">&nbsp;<span class="header"><bean:message key='sort.txt'/></span></td>
<%
	}
%>
            </tr>
            <tr style="vertical-align:top">
                <td class="dialogSpacer">&nbsp;</td>
                <td style="width:80%;">
                    <html:select disabled="true" style="width: 100%;" property="<%= selectPropertyName %>" styleClass="dropdown"
                        styleId="<%= selectStyleId %>" onchange="<%= onChange %>">
                        <html:option key="select.item.txt" value="" styleClass="dropdown"/>
                        <html:optionsCollection property="breakValues" />
                    </html:select>
                </td>
			<td class="buttonSpacer">&nbsp;</td>
			<td style="white-space:nowrap;text-align:left;">
	            <table border="0" cellspacing="0" cellpadding="0" summary="" style="width:100%;">
	                <tr>
	                <td style="white-space:nowrap;text-align:left;">
					    <html:radio disabled="true" styleId="<%= radioStyleId1 %>" value="SORT_ASCENDING" property="<%= radioPropertyName %>" >
						<span class="label">
			                <label id="<%= sortLabelStyleId %>" for="<%= radioStyleId1 %>"><bean:message key="sort_ascending.txt" /></label>
			            </span>
					    </html:radio>
					</td>
					</tr>
					<tr>
					<td style="white-space:nowrap;text-align:left;">
					    <html:radio disabled="true" styleId="<%= radioStyleId2 %>" value="SORT_DESCENDING" property="<%= radioPropertyName %>" >
						<span class="label">
			               <label id="<%= sortLabelStyleId2 %>" for="<%= radioStyleId2 %>"><bean:message key="sort_descending.txt" /></label>
			            </span>
					    </html:radio>
					</td>
					</tr>
				</table>
			</td>
                <td class="buttonSpacer">&nbsp;</td>
                <td style="width:20%;white-space:nowrap;">
                    <html:checkbox disabled="true" property="<%= checkboxPropertyName %>" styleId="<%= checkboxStyleId %>" value="true" onclick="<%=onclick %>">
                        <span class="label">
                            <label id="<%= labelStyleId %>" for="<%= checkboxStyleId %>"><bean:message key="groupbreak.general.newpage.txt" /></label>
                        </span>
                    </html:checkbox>
                </td>
                <td class="dialogSpacer">&nbsp;</td>
            </tr>

<%
    }
%>
                </table>
            </div>
        </td>
        <td class="marginPadding">&nbsp;</td>
    </tr>
            <tr><td colspan="4"></td></tr>            
            <tr>
                <td class="dialogSpacer">&nbsp;</td>
                <td colspan="2" style="vertical-align:top">
                    <fieldset class="dialogFieldset" id="formatBox">
                        <legend>
                            <span id="formatBoxTitle" class="header"><bean:message key="format.txt"/></span>
                        </legend>
                        <table id="FormatTable" summary="" border="0" style="height:100px;">
                            <tr>
                                <td class="dialogSpacer">&nbsp;</td>
                                <td style="white-space:nowrap">
                                  <citation:fontpicker id="groupBreaksFontPicker"
                                            beanName="builderGroupBreaksDialogForm" beanScope="session"  
                                            sampleTextDivId="byGroupSampleText" 
                                            fontFamilyDefaultProperty="fontFamilyDefault"
                                            fontNameProperty="fontFamily" fontSizeProperty="fontSize" 
                                            fontWeightProperty="fontWeight" fontStyleProperty="fontStyle"
                                            textDecorationProperty="textDecoration" 
                                            displayForegroundColors="false" displayBackgroundColors="false"
                                            displayTextAlign="false"
                                            fontType="client"/>
                                </td>
                                <td style="white-space:nowrap">
                                   <citation:colorpicker beanName="builderGroupBreaksDialogForm" beanScope="session" 
                                           supportDefault="false" fontColorProperty="color" sampleTextDivId="byGroupSampleText" 
                                           launchImage='<%=ThemeUtils.getImageFileNameAndSubFolders(request,"Foreground_Color")%>' disableLaunchImage='<%=ThemeUtils.getImageSourceURL(request,"Foreground_Color_Disabled")%>' 
                                           colorPickerDisplayWidth="100px" />
                                </td>
                                <td style="white-space:nowrap">
                                   <citation:colorpicker beanName="builderGroupBreaksDialogForm" beanScope="session" 
                                           supportDefault="false" fontColorProperty="backgroundColor" sampleTextDivId="byGroupSampleText" 
                                           launchImage='<%=ThemeUtils.getImageFileNameAndSubFolders(request,"Background_Color")%>' disableLaunchImage='<%=ThemeUtils.getImageSourceURL(request,"Background_Color_Disabled")%>' 
                                           backgroundFillColor="true" colorPickerDisplayWidth="100px" />
                                </td>
                                <td class="dialogSpacer">&nbsp;</td>
                            </tr>
                            <tr>
                                <td colspan="5" style="text-align:center;">
                                  <div id="byGroupSampleText" 
                                    style="white-space:nowrap; overflow: hidden; line-height: 32pt;
                                           font-family: <bean:write name="builderGroupBreaksDialogForm" property="fontFamily" /> ; 
                                           font-size: <bean:write name="builderGroupBreaksDialogForm" property="fontSize" /> ; 
                                           font-style: <bean:write name="builderGroupBreaksDialogForm" property="fontStyle" /> ; 
                                           color: <bean:write name="builderGroupBreaksDialogForm" property="color" /> ; 
                                           font-weight: <bean:write name="builderGroupBreaksDialogForm" property="fontWeight" /> ; 
                                           text-decoration: <bean:write name="builderGroupBreaksDialogForm" property="textDecoration" /> ;
                                           background-color: <bean:write name="builderGroupBreaksDialogForm" property="backgroundColor" /> ;">
                                       <bean:message key="sample.text.txt"/>
                                  </div>
                                </td>
                            </tr>
                        </table>
                    </fieldset>
                </td>
                <td class="dialogSpacer">&nbsp;</td>
            </tr>
            <tr>
                <td class="dialogSpacer">&nbsp;</td>
                <td colspan="2">
                   <html:checkbox property="labelValue" styleId="labelValue" value="true">
                       <span class="label" id="labelValueLabel"><label for="labelValue">
                          <bean:message key="groupbreak.general.labelcat.txt" /></label></span>
                   </html:checkbox>
                </td>
                <td class="dialogSpacer">&nbsp;</td>
            </tr>
<% if (maxByGroups < 1) { %>
				    <tr>
        			<td colspan="4">
            		<span class="errorMessages"><%=PagePropertyBean.getMessage(pageContext, "warning.wizard.not.enough.group.breaks.txt")%></span>
        			</td>
    				</tr>
<% } else { %>
				    <tr>
        			<td colspan="4">&nbsp;</td>
    				</tr>
<% } %>
        </table>
        <%-- dynamic text property sheet declaration --%>
        <table id="dynamicTextTabBody" style="width:600px;height:420px;display:none;" 
        		border="0" cellpadding="0" cellspacing="0" summary="">
            <tr>
                <td class="dialogSpacer">&nbsp;</td>
                <td style="width:35%;">&nbsp;</td>
                <td style="width:30%;">&nbsp;</td>
                <td style="width:25%;">&nbsp;</td>
                <td class="dialogSpacer">&nbsp;</td>
            </tr>
            <tr>
                <td class="dialogSpacer">&nbsp;</td>
                <td class="header"><bean:message key="groupbreak.dt.forlevel.txt" /></td>
                <td colspan="2">
                    <select style="width:100%;" id="dtBreakSelect" class="dropdown" onchange="onSelChangeDT();"></select>
                </td>
                <td class="dialogSpacer">&nbsp;</td>
            </tr>
            <tr>
                <td class="dialogSpacer">&nbsp;</td>
                <td class="header"><bean:message key="groupbreak.dt.showdata.txt" /></td>
                <td colspan="2">
                    <html:select style="width:100%;" property="dataValue" styleClass="dropdown" styleId="dtDataSelect" 
                            onchange="onSelChangeDT();">                    
                        <html:optionsCollection property="dataValues" />                       
                    </html:select>
                </td>
                <td class="dialogSpacer">&nbsp;</td>
            </tr>
            
            <tr><td class="linePadding" colspan="5">&nbsp;</td></tr>
            <tr><td class="linePadding" colspan="5">&nbsp;</td></tr>
            
            <tr>
                <td class="dialogSpacer">&nbsp;</td>
                <td class="header" colspan="3"><bean:message key="groupbreak.dt.levelvalue.txt" /></td>
                <td class="dialogSpacer">&nbsp;</td>
            </tr>
            <tr>
                <td class="dialogSpacer">&nbsp;</td>
                <td style="vertical-align: top;" colspan="2">
                    <html:select multiple="true" styleId="dtChoicesSelect" property="unused" styleClass="dropdown" style="width:100%" size="10" onchange="onChoicesChange();" >
                        <html:optionsCollection property="flattenedList" />                       
                    </html:select>
                </td>
                <td style="vertical-align:top;width:25%;">
                	<%
										CitationButton addButton = CitationButton.createStandaloneButton(request, "dtAddButton",
										    PagePropertyBean.getLabelWithMnemonic(pageContext,"groupbreak.dt.add.btn.txt"),
										    "javascript:onAddButton();");
										addButton.setStyle("margin-left:10px;width:90%;");
										addButton.setAccessKey(PagePropertyBean.getMnemonic(pageContext,"groupbreak.dt.add.btn.txt"));
										addButton.setAlternateText(PagePropertyBean.getLabelWithoutMnemonic(pageContext,"groupbreak.dt.add.btn.txt"));
										addButton.write(out);
									%>
                    <br />
                	<%
										CitationButton removeButton = CitationButton.createStandaloneButton(request, "dtRemoveButton",
										    PagePropertyBean.getLabelWithMnemonic(pageContext,"groupbreak.dt.remove.btn.txt"),
										    "javascript:onRemoveButton();");
										removeButton.setStyle("margin-left:10px;width:90%;");
										removeButton.setAccessKey(PagePropertyBean.getMnemonic(pageContext,"groupbreak.dt.remove.btn.txt"));
										removeButton.setAlternateText(PagePropertyBean.getLabelWithoutMnemonic(pageContext,"groupbreak.dt.remove.btn.txt"));
										removeButton.write(out);
									%>
                </td>
                <td class="dialogSpacer">&nbsp;</td>
            </tr>
            <tr>
                <td class="dialogSpacer">&nbsp;</td>
                <td colspan="2"><span class="label" style="font-style: italic;"><bean:message key="groupbreak.dt.hint.txt" /></span></td>
                <td class="dialogSpacer">&nbsp;</td>
                <td class="dialogSpacer">&nbsp;</td>
            </tr>
            <tr><td colspan="5" style="height:42px;" class="linePadding">&nbsp;</td></tr>
        </table>
    <script type="text/javascript"> /*<![CDATA[*/
	    enableElement(<%=maxByGroups%>, 'bygroupLevel', 'newPageCheckedLabel', 'newPageChecked', 'bygroupSort', 'sortLabel', 'sortString');
<% if (maxByGroups < 1) { %>
    if (findDOM('bygroupLevel1') != null) {
        findDOM('bygroupLevel1').disabled = true;
    }
    if (findDOM('bygroupSort1') != null) {
        findDOM('bygroupSort1').disabled = true;
    }
    if (findDOM('bygroupSort1_2') != null) {
        findDOM('bygroupSort1_2').disabled = true;
    }
    if (findDOM('sortLabel1') != null) {
        findDOM('sortLabel1').className = 'labeldisabled';
    }
    if (findDOM('sortLabel1_2') != null) {
        findDOM('sortLabel1_2').className = 'labeldisabled';
    }
    if (findDOM('newPageChecked1') != null) {
        findDOM('newPageChecked1').disabled = true;
    }
    if (findDOM('newPageCheckedLabel1') != null) {
        findDOM('newPageCheckedLabel1').className = 'labeldisabled';
    }
<% } %>
    	enableLabelCategories();
    /*]]>*/ </script>

<script type="text/javascript"> 
/*<![CDATA[*/
        onLoad(); 
        /* returns true if the supplied label exists; otherwise, returns false.                  */
        function optionExists(choices, group, label)
        {
            if (null == group || null == label)
                return false;
                
            var options = choices.options;
            if (null == options) return false;
                
            for (var i=0; i < options.length; i++)
            {
                if (options[i].value == group+ '/' + label)
                    return true;
            }
            return false;
        }
        /* called when either the category or measure selection box changes. */
        /* Enables the add button if the combination of the two selection    */
        /* boxes does not exist in the choices selection box; otherwise, the */
        /* add button is disabled.                                           */
        function onSelChangeDT()
        {
            var exists = false;
            var breaks = findDOM('dtBreakSelect');
            var category = breaks.options[breaks.selectedIndex].text;
            if (breaks.options.length > 0)
            {
                var measures = findDOM('dtDataSelect');
                if (measures.options.length > 0) { // if no measures, skip measures check
	                var measure = measures.options[measures.selectedIndex].text;
	                exists = optionExists(findDOM('dtChoicesSelect'), category, measure);
	              }
	              else {
	              	exists = true; // no measures, so no pair worth adding
	              }
            }
            var buttonState = (exists) ? setButtonState.DISABLED : setButtonState.ENABLED;
            setButtonState(null, 'dtAddButton', buttonState);
        }
        /* append the selected item in the from selection box to the supplied */
        /* selection box.                                                     */
        function buildBreaks(sel, from)
        {
            if (from.selectedIndex == 0)
                return;
            createOption(sel, from.options[from.selectedIndex].text, from.options[from.selectedIndex].value);
        }
        /* called each time the dynamic text tab is activated to ensure that the */
        /* information being displayed corresponds to the information chosen on  */
        /* the general page.                                                     */
        function populateDynamicTextTab()
        {   
            // obtain break values and populate
            var breaks = findDOM('dtBreakSelect');
            breaks.options.length = 0;
            // must do a loop here
            var levelNum = 1;
            bygroup = findDOM('bygroupLevel1');
            while (bygroup != null) {
            	buildBreaks(breaks, bygroup);
                levelNum = levelNum + 1;
            	bygroup = findDOM('bygroupLevel' + levelNum);
            }
            
            breaks.disabled = (breaks.options.length == 0 ? true : false);
            findDOM('dtDataSelect').disabled = breaks.disabled;
            findDOM('dtChoicesSelect').disabled = breaks.disabled;                
            
            if (breaks.disabled)
            {
                findDOM('dtChoicesSelect').options.length = 0;
                onRemoveButton();
                setButtonState(null, 'dtAddButton', setButtonState.DISABLED);
                setButtonState(null, 'dtRemoveButton', setButtonState.DISABLED);
            } else {
                onSelChangeDT();
                validateOptionChoices();
            }                        
        }
        /* add the category and measure chosen in their appropriate selection boxes, to */
        /* the choices selection box.  */
        function onAddButton()        
        {        
            var breaks = findDOM('dtBreakSelect');
            var category = breaks.options[breaks.selectedIndex].text;
            var measures = findDOM('dtDataSelect');
            var label = measures.options[measures.selectedIndex].text;
            createOption(findDOM('dtChoicesSelect'), (category + ' / ' + label), (category+'/'+label)); 
            setButtonState(null, 'dtAddButton', setButtonState.DISABLED);
            findDOM('dtChoicesSelect').disabled = false;
        		findDOM('dtChoicesSelect').focus();
        }
        /* loop through the items in the choices selection box and remove those that */
        /* have been selected.                            */
        function onRemoveButton()
        {
        	var removed = false;
            var choices = findDOM('dtChoicesSelect');
            for (var i=choices.length-1; i > -1; i--)
            {
                if (choices[i].selected) {
                    choices.remove(i);
                    removed = true;
                }
            }
            setButtonState(null, 'dtRemoveButton', setButtonState.DISABLED);
            adjustFocus('dtChoicesSelect');
            if (!findDOM('dtBreakSelect').disabled)
                onSelChangeDT();
        }
        
        function adjustFocus(choicesId)
        {
            var choices = findDOM(choicesId);
            choices.disabled = (choices.length == 0) ? true : false;  
            var removeButtonState = setButtonState.DISABLED;
            if (choices.length > 0) {
            	choices.focus();
	            for (var i=0; i < choices.length; i++)
	            {
	                if (choices[i].selected)
	                {
	                    removeButtonState = setButtonState.ENABLED;
	                    break;
            }
	            }
	            }
            else { 
                // if there are no items, move focus to "for group level"
                // if that's disabled, focus on the ok button - S0659150
                var breakSelect = findDOM('dtBreakSelect');
                if (breakSelect != null && !breakSelect.disabled) {
                    breakSelect.focus();
                }
                else {
	            	findDOM('okButton').focus();
                }	
            }
            setButtonState(null, 'dtRemoveButton', removeButtonState);
         }
        
        /* create an OPTION element using the supplied label and value and */
        /* append it to the supplied element.                              */
        function createOption(el, label, value)   
        {
            el.options[el.options.length] = new Option(label, value);
        }
        /* executed when the user makes a change to the choices selection box. When  */
        /* something is actually selected, then enable the remove button; otherwise, */
        /* the remove button is disabled.                                            */
        function onChoicesChange()
        {
            // if something is selected, then enable the remove button
            var choices = findDOM('dtChoicesSelect');
            var disabled = true;
            for (var i=0; i < choices.length; i++)
            {
                if (choices[i].selected)
                {
                    disabled = false;
                    break;
                }
            }
            var buttonState = (disabled) ? setButtonState.DISABLED : setButtonState.ENABLED;
            setButtonState(null, 'dtRemoveButton', buttonState);
        } 
        /* loop through the OPTION elements of the choices selection    */
        /* and ensure that each entry is valid in terms of: (1) there is a chosen    */
        /* category and (2) there is a chosen measure that corresponds to the        */
        /* element being interrogated. When false, remove the entry from the choices */
        /* selection box                                                             */         
        function validateOptionChoices()
       {
            var choices = findDOM('dtChoicesSelect');
            for (var i=0; i < choices.options.length; i++)
            {
                var option = choices.options[i];
                var values = option.value.split('/', 2);
                if (existsInSelection(findDOM('dtDataSelect'), values[1]) && 
                    existsInSelection(findDOM('dtBreakSelect'), values[0]))
                    continue;
                option.selected = true;
            }
            adjustFocus('dtChoicesSelect');
        }
        /* return true when the supplied label matches the text of one of the */
        /* items in the supplied selection box; otherwise, return false.           */
        function existsInSelection(sel, label)
        {
            for (var i=0; i < sel.options.length; i++)
            {
                if (sel.options[i].text == label)
                    return true;                
            }
            return false;
        }
        
function checkInUse(numberOfGroupBreakRows, selectPrefix, inUseStringId) {

  // check each row. If the selected item is in use, add it to the list of labels to be returned
    var inUseString = findDOM(inUseStringId);
    var listOfLabels = new Array();
    if (inUseString == null) return listOfLabels;
	for (var i=1; i<=numberOfGroupBreakRows; i++) {
		var selectId = selectPrefix + i;
		var select = findDOM(selectId);
		if (select != null) {
			if (select.selectedIndex > 0) { // don't bother if value is none
				var index = findDOM(select).selectedIndex - 1; // subtract 1 to skip over None
				if (inUseString.value.charAt(index) == '1') { // data item is in use
		    		listOfLabels[listOfLabels.length] = select.options[select.selectedIndex].text;
				}	
			}
		}
	}
	return listOfLabels;
}
        
/*]]>*/ 
</script>

<% } catch (Exception ex) {
    PageErrorProcessor.setJspError(ex, pageContext, out);
} // END: DEBUG %>
